/*
 * Copyright 2022 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */
#include "pydoc_macros.h"
#define D(...) DOC(gr,lora_sdr, __VA_ARGS__ )
/*
  This file contains placeholders for docstrings for the Python bindings.
  Do not edit! These were automatically extracted during the binding process
  and will be overwritten during the build process
 */


 
 static const char *__doc_gr_lora_sdr_frame_src = R"doc(

Constructor Specific Documentation:

Produce frames at a regular interval.

Output frames are composed of 8 upchirps, 2 sync words (8 and 16), 2.25 downchirps and 'pay_len' symbols. The first frame is output after 'offset' samples and each frame after is spaced of 'delay' samples. If rand_sto is true, the sto will vary for each frame, with a value uniformly distributed in [0, os_factor*2^sf). Zeros are output between frames. If a file_sink is connected, the payload will be random for each frame and saved to the file selected. Else a fix payload defined in frame_src_impl.cc will be used.

Args:
    sf : Spreading factor
    pay_len : length of the payload in number of symbols
    delay : number of samples between two frames
    offset : number of samples before the first frame (used to emulate the sampling frequency offset).! The offset of the first user should be smaller than 2^'sf'*'os_factor'!
    cfo : Carrier frequency offset
    n_frames : Number of frames to send
    os_factor : Oversampling factor
    rand_sto : Indicate to use a random sto for each frame)doc";


 static const char *__doc_gr_lora_sdr_frame_src_frame_src = R"doc()doc";


 static const char *__doc_gr_lora_sdr_frame_src_make = R"doc(

Constructor Specific Documentation:

Produce frames at a regular interval.

Output frames are composed of 8 upchirps, 2 sync words (8 and 16), 2.25 downchirps and 'pay_len' symbols. The first frame is output after 'offset' samples and each frame after is spaced of 'delay' samples. If rand_sto is true, the sto will vary for each frame, with a value uniformly distributed in [0, os_factor*2^sf). Zeros are output between frames. If a file_sink is connected, the payload will be random for each frame and saved to the file selected. Else a fix payload defined in frame_src_impl.cc will be used.

Args:
    sf : Spreading factor
    pay_len : length of the payload in number of symbols
    delay : number of samples between two frames
    offset : number of samples before the first frame (used to emulate the sampling frequency offset).! The offset of the first user should be smaller than 2^'sf'*'os_factor'!
    cfo : Carrier frequency offset
    n_frames : Number of frames to send
    os_factor : Oversampling factor
    rand_sto : Indicate to use a random sto for each frame)doc";

  
