/*
 * Copyright 2022 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */
#include "pydoc_macros.h"
#define D(...) DOC(gr,lora_sdr, __VA_ARGS__ )
/*
  This file contains placeholders for docstrings for the Python bindings.
  Do not edit! These were automatically extracted during the binding process
  and will be overwritten during the build process
 */


 
 static const char *__doc_gr_lora_sdr_mu_synchro = R"doc(

Constructor Specific Documentation:

Synchronise to the strongest user present.

This block main purpose is to always output samples that are synchronised to the strongest user present. It applies the STO and CFO correction required, based on the estimation provided by the user detection stage. It outputs windows of samples that can be used by the demodulation stage to correctly interpet the user configuration. Each window start with a tag specifying the power of each user, the size of the window, the type of symbol present in the windows for each user (VOID, UPCHIRP, SYNC_WORD, DOWNCHIRP, QUARTER_DOWN, PAYLOAD or UNDETERMINED), the offset between the beginning of the window and the new symbol of the non-synchronised user and the CFO between the two users.

Args:
    sf : Spreading factor
    os_factor : Oversampling factor
    len : Number of symbols in payload)doc";


 static const char *__doc_gr_lora_sdr_mu_synchro_mu_synchro = R"doc()doc";


 static const char *__doc_gr_lora_sdr_mu_synchro_make = R"doc(

Constructor Specific Documentation:

Synchronise to the strongest user present.

This block main purpose is to always output samples that are synchronised to the strongest user present. It applies the STO and CFO correction required, based on the estimation provided by the user detection stage. It outputs windows of samples that can be used by the demodulation stage to correctly interpet the user configuration. Each window start with a tag specifying the power of each user, the size of the window, the type of symbol present in the windows for each user (VOID, UPCHIRP, SYNC_WORD, DOWNCHIRP, QUARTER_DOWN, PAYLOAD or UNDETERMINED), the offset between the beginning of the window and the new symbol of the non-synchronised user and the CFO between the two users.

Args:
    sf : Spreading factor
    os_factor : Oversampling factor
    len : Number of symbols in payload)doc";

  
