/*
 * Copyright 2022 Free Software Foundation, Inc.
 *
 * This file is part of GNU Radio
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 */
#include "pydoc_macros.h"
#define D(...) DOC(gr,lora_sdr, __VA_ARGS__ )
/*
  This file contains placeholders for docstrings for the Python bindings.
  Do not edit! These were automatically extracted during the binding process
  and will be overwritten during the build process
 */


 
 static const char *__doc_gr_lora_sdr_signal_detector = R"doc(

Constructor Specific Documentation:

This block becomes transparent after detecting a LoRa preamble at his input.

It's main purpose is to prevent the rest of the receiver to run continuously as the matched filtering steps are computationally intensive. The detection of a LoRa preamble is based on the FFT of 'fft_symb' dechirped symbols. If 'fft_symb' upchirps are in the FFT, a bin should have significantly more energy than others. The decision is taken based on the ratio between the amplitude of the main bin and the median amplitude of all bins. Once a detection is triggered, the block will become transparent for the previous 'margin' symbols and the next 'transp_len' symbols. The transparency duration is reset if a new trigger occurs before the end of the previous tranparency duration.

Args:
    sf : Spreading factor
    os_factor : Oversampling factor
    threshold : Minimal ratio between the max FFT bin and the median of the bins.(a value of 10 has proven to be effective)
    margin : Number of symbols preceding the detection that will be output at the detection time. (margin in case of detection triggering late on the preamble)
    fft_symb : Number of symbols used in the FFT (should be less than the number of preamble upchirps, 4 is an efficient value for the FFT complexity)
    transp_len : minimal duration in symbols after a triggered detection (englobing the preamble and payload symbol is a good idea))doc";


 static const char *__doc_gr_lora_sdr_signal_detector_signal_detector = R"doc()doc";


 static const char *__doc_gr_lora_sdr_signal_detector_make = R"doc(

Constructor Specific Documentation:

This block becomes transparent after detecting a LoRa preamble at his input.

It's main purpose is to prevent the rest of the receiver to run continuously as the matched filtering steps are computationally intensive. The detection of a LoRa preamble is based on the FFT of 'fft_symb' dechirped symbols. If 'fft_symb' upchirps are in the FFT, a bin should have significantly more energy than others. The decision is taken based on the ratio between the amplitude of the main bin and the median amplitude of all bins. Once a detection is triggered, the block will become transparent for the previous 'margin' symbols and the next 'transp_len' symbols. The transparency duration is reset if a new trigger occurs before the end of the previous tranparency duration.

Args:
    sf : Spreading factor
    os_factor : Oversampling factor
    threshold : Minimal ratio between the max FFT bin and the median of the bins.(a value of 10 has proven to be effective)
    margin : Number of symbols preceding the detection that will be output at the detection time. (margin in case of detection triggering late on the preamble)
    fft_symb : Number of symbols used in the FFT (should be less than the number of preamble upchirps, 4 is an efficient value for the FFT complexity)
    transp_len : minimal duration in symbols after a triggered detection (englobing the preamble and payload symbol is a good idea))doc";

  
